/*
 * Copyright 2010 Graz University of Technology
 *
 * Licensed under the EUPL, Version 1.1 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 * http://www.osor.eu/eupl/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 */
package at.gv.egiz.moodle.eidconnector.webapp;

import javax.servlet.ServletContextEvent;

import org.opensaml.xml.ConfigurationException;

import at.gv.egiz.moodle.eidconnector.core.CleanUpThread;
import at.gv.egiz.moodle.eidconnector.core.config.Configuration;
import at.iaik.commons.jconfig.JConfigDefaultConfigurationException;
import at.iaik.commons.webapp.DefaultServletContextListener;

/**
 * @author AT-TUG (Thomas Knall)
 */
public class ContextListener extends DefaultServletContextListener {
   
   @Override
   public void done(ServletContextEvent sce) {
   }

   @Override
   public void init(ServletContextEvent sce) {
      // initialize configuration
      try {
         // application config
         String webXMLApplicationConfigURI = sce.getServletContext().getInitParameter(Configuration.WEB_XML_INIT_PARAMETER);
         Configuration.init(webXMLApplicationConfigURI);

         CleanUpThread.start();

      } catch (JConfigDefaultConfigurationException e) {
         e.printStackTrace();
         assert (false) : "Application cannot be successfully initialized due to configuration errors.";
      } catch (ConfigurationException e) {
         e.printStackTrace();
         assert (false) : "Application cannot be successfully initialized due to configuration errors.";
      }
      
   }

   @Override
   public String getApplicationName() {
      return Configuration.APPLICATION_NAME;
   }

}
