/*
 * Copyright 2010 Graz University of Technology
 *
 * Licensed under the EUPL, Version 1.1 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 * http://www.osor.eu/eupl/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 */
package at.gv.egiz.moodle.eidconnector.webapp.struts.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * @author AT-TUG (Thomas Knall)
 */
public class ErrorAction extends CommonAction {

   private final Logger log = Logger.getLogger(ErrorAction.class);
   
   public ActionForward sendError500(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
      log.error("Sending http error code 500.");
      response.sendRedirect(response.encodeRedirectURL("500.do"));
      return null;
   }
   
   public ActionForward sendError403(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
      log.error("Sending http error code 403.");
      response.sendRedirect(response.encodeRedirectURL("403.do"));
      return null;
   }
   
   public ActionForward sendError400(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
      log.error("Sending http error code 400.");
      response.sendRedirect(response.encodeRedirectURL("400.do"));
      return null;
   }
   
   public ActionForward sendError404(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
      log.error("Sending http error code 404.");
      response.sendRedirect(response.encodeRedirectURL("404.do"));
      return null;
   }
   
}
