/*
 * Copyright 2010 Graz University of Technology
 *
 * Licensed under the EUPL, Version 1.1 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 * http://www.osor.eu/eupl/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 */
package at.gv.egiz.moodle.eidconnector.webapp.struts.form;

import java.io.Serializable;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.log4j.Logger;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.validator.ValidatorForm;

import at.iaik.commons.data.Trimable;

/**
 * @author AT-TUG (Thomas Knall)
 */
public class RegistrationForm extends ValidatorForm implements Serializable, Trimable {

   private static final long serialVersionUID = 1L;
   private static final Logger LOG = Logger.getLogger(RegistrationForm.class);
   
   private String moodleUserName;
   private String moodlePassword;
   private String registrationType;

   public RegistrationForm() {
      this.moodleUserName = null;
   }
   
   public String getMoodleUserName() {
      return this.moodleUserName;
   }

   public void setMoodleUserName(String moodleUserName) {
      this.moodleUserName = moodleUserName;
   }

   public String getMoodlePassword() {
      return this.moodlePassword;
   }

   public void setMoodlePassword(String moodlePassword) {
      this.moodlePassword = moodlePassword;
   }

   public String getRegistrationType() {
      return this.registrationType;
   }

   public void setRegistrationType(String registrationType) {
      this.registrationType = registrationType;
   }

   @Override
   public ActionErrors validate(ActionMapping mapping, HttpServletRequest request) {
      ActionErrors actionErrors = super.validate(mapping, request);
      
      // nothing to check here
      
      return actionErrors; 
   }

   @Override
   public String toString() {
      return
         new ToStringBuilder(this)
            .append("moodleUserName", this.moodleUserName)
            .append("moodlePassword", this.moodlePassword != null ? "<set>" : "<not set>")
            .append("registrationType", this.registrationType)
         .toString();
   }

   public void trim() {
      if (this.moodleUserName != null) {
         this.moodleUserName = this.moodleUserName.trim();
      }
      if (this.registrationType != null) {
         this.registrationType = this.registrationType.trim();
      }
   }

}
