<%@ page contentType="text/html; charset=UTF-8" language="java" errorPage=""%>

<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean"%>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html"%>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic"%>

<%@ page import="at.gv.egiz.moodle.eidconnector.webapp.struts.RegistrationType" %>
<%@ page import="at.gv.egiz.moodle.eidconnector.webapp.struts.form.RegistrationForm" %>
<%@ page import="at.gv.egiz.moodle.eidconnector.core.config.Configuration" %>
<%@ page import="at.iaik.commons.webapp.WebConstants" %>
<%@ page import="at.iaik.commons.util.WebAppUtil" %>

<%
	String pageXOffset = request.getAttribute(WebConstants.XOFFSET_ID) != null ? (String)request.getAttribute(WebConstants.XOFFSET_ID) : "0";
	String pageYOffset = request.getAttribute(WebConstants.YOFFSET_ID) != null ? (String)request.getAttribute(WebConstants.YOFFSET_ID) : "0";
	RegistrationForm rf = (RegistrationForm) WebAppUtil.getAttribute(request, "registrationForm");
	boolean enableSelection = Configuration.isMoodleExistingAccountsEnabled() && Configuration.isMoodleNewAccountsEnabled();
	boolean supportOnlyExistingAccounts = !Configuration.isMoodleNewAccountsEnabled();
	boolean enableCredentialInput = supportOnlyExistingAccounts || (rf != null && RegistrationType.EXISTING_ACCOUNT.name().equals(rf.getRegistrationType()));
%>

<html:html xhtml="true">

	<head>
		<jsp:include page="/jsp/common/pagemainheader.jsp">
			<jsp:param name="titleKey" value="application.title"/>
		</jsp:include>
		<script language="javascript" type="text/javascript">
			<!--
			function handleStart() {
				if (document.getElementById('moodleUserNameId').value == "") {
					document.getElementById('moodleUserNameId').focus();
				} else if (document.getElementById('moodlePasswordId').value == "") {
					document.getElementById('moodlePasswordId').focus();
				} else {
					// document.getElementById("submitButton").focus();
					document.getElementById('moodleUserNameId').focus();
				}
			}
			function handleReset() {
				document.getElementById('moodleUserNameId').value = "";
				document.getElementById('moodlePasswordId').value = "";
				document.getElementById("moodleUserNameId").focus();
			}
			function handleSubmit() {
				// document.getElementById("submitButton").focus();
				disable3Elements("submitButton", "resetButton", "cancelButton");
				document.forms[0].submit();
				return(false);
			}
			-->
		</script>
	</head>
	
	<body>

		<html:form method="post" action="/register.do" enctype="multipart/form-data" acceptCharset="utf-8">
			
			<table border="0">
				<jsp:include page="/jsp/common/pagemessageheader.jsp"/>
			</table>
			<!-- ================================================================ Start Table -->
			<table align="center" border="0" class="boundingbox800">
				<tr>
					<th class="section" align="center"><bean:message key="page.registration.subtitle"/></th>
				</tr>
				<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  Start fields -->
				<tr>
					<td align="left"><bean:message key="page.registration.note"/></td>
				</tr>
		
				<% if (enableSelection) { %>
					<tr>
						<td align="left"><bean:message key="page.registration.note.selection"/></td>
					</tr>
					<tr>
						<td align="left">
			
							<fieldset>
								<legend><bean:message key="page.registration.type"/></legend>
								<table border="0">
									<colgroup>
										<col width="140px"/>
										<col width="13px"/>
										<col width="13px"/>
										<col/>
									</colgroup>
									
									<!-- registrationType -->
									<tr>
										<td align="right" <logic:messagesPresent property="registrationType">class="formerrormessage"</logic:messagesPresent>>
											<bean:message key="page.registration.type.label"/>
										</td>
										<jsp:include page="/jsp/common/labelsymbols.jsp">
											<jsp:param name="property"  value="registrationType"/>
											<jsp:param name="mandatory" value="true"/>
											<jsp:param name="helpFile"  value=""/>
										</jsp:include>
										<td align="left">
											<html:radio property="registrationType" styleId="createNewAccountId" value="<%= RegistrationType.NEW_ACCOUNT.name() %>" onclick="return doSubmitAction('updateForm');"/>
											<label for="createNewAccountId"><bean:message key="page.registration.type.createnew"/></label>
											<br/>
											<html:radio property="registrationType" styleId="useExistingAccountId" value="<%= RegistrationType.EXISTING_ACCOUNT.name() %>" onclick="return doSubmitAction('updateForm');"/>
											<label for="useExistingAccountId"><bean:message key="page.registration.type.useexisting"/></label>
										</td>
									</tr>
			
								</table>
							</fieldset>
			
						</td>
					</tr>
				<% } // end if %>
		
				<% if (enableCredentialInput) { %>
					<tr>
						<td align="left"><bean:message key="page.registration.disclaimer"/></td>
					</tr>
					<tr>
						<td align="left">
			
							<fieldset>
								<legend><bean:message key="page.registration.account"/></legend>
								<table border="0">
									<colgroup>
										<col width="140px"/>
										<col width="13px"/>
										<col width="13px"/>
										<col/>
									</colgroup>
									
									<!-- moodleUserName -->
									<tr>
										<td align="right" <logic:messagesPresent property="moodleUserName">class="formerrormessage"</logic:messagesPresent>>
											<label for="moodleUserNameId"><bean:message key="page.registration.moodleusername"/></label>
										</td>
										<jsp:include page="/jsp/common/labelsymbols.jsp">
											<jsp:param name="property"  value="moodleUserName"/>
											<jsp:param name="mandatory" value="true"/>
											<jsp:param name="helpFile"  value=""/>
										</jsp:include>
										<td align="left">
											<html:text property="moodleUserName" size="40" maxlength="100" styleId="moodleUserNameId"/>
										</td>
									</tr>
			
									<!-- moodlePassword -->
									<tr>
										<td align="right" <logic:messagesPresent property="moodlePassword">class="formerrormessage"</logic:messagesPresent>>
											<label for="moodlePasswordId"><bean:message key="page.registration.moodlepassword"/></label>
										</td>
										<jsp:include page="/jsp/common/labelsymbols.jsp">
											<jsp:param name="property"  value="moodlePassword"/>
											<jsp:param name="mandatory" value="true"/>
											<jsp:param name="helpFile"  value=""/>
										</jsp:include>
										<td align="left">
											<html:password property="moodlePassword" size="40" maxlength="100" styleId="moodlePasswordId"/>
										</td>
									</tr>
			
								</table>
							</fieldset>
			
						</td>
					</tr>
				<% } // end if %>
		
				<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  End fields -->
				<tr>
					<td align="center">
						<input type="hidden" name="action" value="submit"/>
						<input type="hidden" name="<%= WebConstants.XOFFSET_ID %>" value="0"/>
						<input type="hidden" name="<%= WebConstants.YOFFSET_ID %>" value="0"/>
						<% if (supportOnlyExistingAccounts) { %>
							<input type="hidden" name="registrationType" value="<%= RegistrationType.EXISTING_ACCOUNT.name() %>"/>
						<% } // end if %>
						<html:submit styleClass="formbutton" onclick="return handleSubmit();" styleId="submitButton"><bean:message key="page.registration.submit"/></html:submit>
						<% if (enableCredentialInput) { %>
							<html:reset styleClass="formbutton" onclick="handleReset(); return false;" styleId="resetButton"><bean:message key="page.registration.reset"/></html:reset>
						<% } // end if %>
						<html:cancel styleClass="formbutton" onclick="bCancel=true;" styleId="cancelButton"><bean:message key="page.registration.cancel"/></html:cancel>
					</td>
				</tr>
			</table>
			<!-- ================================================================== End Table -->
	
		</html:form>
	
		<script language="javascript" type="text/javascript">
			<!--
			busyMessage = "<bean:message key='page.registration.pleasewaitmessage'/>";
			window.scrollTo(<%= pageXOffset %>, <%= pageYOffset %>);
			<% if (enableCredentialInput) { %>
				handleStart();
			<% } // end if %>
			-->
		</script>
	
	</body>

</html:html>
