<?php // $Id: index.php,v 1.15.2.4 2008/12/08 10:45:47 exe-cutor Exp $
      // Designed to be redirected from moodle/login/index.php

    require('../../config.php');
    require_once('http_client.php');
    
    $ticketparamname = "ticket";
    $contentok_regex = "/^(\s*(<ok\/>)|(<ok>[^<>]*<\/ok>\s*))$/i";
    
    if (isloggedin() && $USER->username != 'guest') {      // Nothing to do
        if (isset($SESSION->wantsurl) and (strpos($SESSION->wantsurl, $CFG->wwwroot) === 0)) {
            $urltogo = $SESSION->wantsurl;    /// Because it's an address in this site
            unset($SESSION->wantsurl);

        } else {
            $urltogo = $CFG->wwwroot.'/';      /// Go to the standard home page
            unset($SESSION->wantsurl);         /// Just in case
        }

        redirect($urltogo);
    }

    $pluginconfig   = get_config('auth/stork');
    $storkauth = get_auth_plugin('stork');
    
    // Check whether STORK is configured properly
    if (empty($pluginconfig->user_attribute) || empty($pluginconfig->connector_url)) {
        print_error('stork_not_set_up_error', 'auth');
        exit;
     }

	// check if ticket has been provided by moodle eid connector
	$ticket = $_REQUEST[$ticketparamname];
	
	// ticket is mandatory
	if (!empty($ticket)) {
		
		// ticket has been given; fetch Moodle username/age and other attributes requesting eid connector
		$connector_url = $pluginconfig->connector_url;
		$bits = parse_url($connector_url);
		$host = $bits['host'];
		$port = isset($bits['port']) ? $bits['port'] : 80;
		$path = isset($bits['path']) ? $bits['path'] : '/';
		if (isset($bits['query'])) {
			$path .= '?' . $bits['query'] . '&';
		} else {
			$path .= '?';
		}
		$path .= $ticketparamname . '=' . urlencode($ticket);
		$client = new HttpClient($host, $port);
		
		// fetch credentials
		if ($client->get($path)) {
			
			// check if http status is 200
			if ($client->getStatus() != 200) {
				print_error('stork_connector_not_reporting_ok_error', 'auth');
				exit;
			}
			
			// request successfully completed; validate results
			$content = $client->getContent();
			// content must equal to <ok/>
			$cmatch = preg_match($contentok_regex, $content);
			if (!isset($content) || !$cmatch ) {
				print_error('stork_connector_not_reporting_ok_error', 'auth');
				exit;
			}
			
			// moodle user name is mandatory
			$moodleusername_base64 = $client->getHeader($pluginconfig->user_attribute);
			if (empty($moodleusername_base64)) {
				print_error('stork_no_username_error', 'auth');
				exit;
			}
			$moodleusername = base64_decode($moodleusername_base64);

			// if qaa level has been set to 1-4, qaa level is mandatory
			$qaalevel_base64 = $client->getHeader($pluginconfig->qaalevel_attribute);
			if (empty($qaalevel_base64)) {
				if (isset($pluginconfig->min_qaalevel) && $pluginconfig->min_qaalevel != '0') {
					print_error('stork_no_qaalevel_error', 'auth');
					exit;
				}
			} else {
				$qaalevel = base64_decode($qaalevel_base64);
				if (isset($pluginconfig->min_qaalevel) && ($qaalevel < $pluginconfig->min_qaalevel)) {
					print_error('stork_insufficient_qaalevel_error', 'auth');
					exit;
				}
			}

			// age (optional) is evaluated separately from other attributes since Moodle does not
			// support age and we do not want to persist the value (should remain temporary)
			if (isset($pluginconfig->age_attribute)) {
				$age_base64 = $client->getHeader($pluginconfig->age_attribute);
			}
			
			// iterate over all configured attribute mappings and put them in session
			$stork = array();
			$mappedattributes = $storkauth->get_attributes();
	        foreach ($mappedattributes as $key=>$value) {
	        	// Check if attribute is present
	        	$headervalue = $client->getHeader($value);
	            if (!isset($headervalue)) {
	                continue;
	            }
	            // put respective attribute in data structure for session storage
                $stork[$key] = base64_decode($headervalue);
	        }
	        
			// put username in data structure for session storage
			$stork['username'] = $moodleusername;
			
			// put data structure in session
			$_SESSION['STORK_SESSION'] = $stork;
						
			// everything seems fine; we got a user name
			if (!$storkauth->user_login($moodleusername, $ticket)) {
				print_error('stork_internal_error', 'auth');
				exit;
			}
			
			// ---- OK ----
            $USER = authenticate_user_login($moodleusername, $ticket);
            
            // put age in temporary user object
            if (isset($age_base64)) {
            	$USER->age = base64_decode($age_base64);
            } else {
            	unset($USER->age);
            }
            
            // set qaa level
            if (isset($qaalevel)) {
	            $USER->qaalevel = $qaalevel;
            } else {
	            unset($USER->qaalevel);
            }
            
            $USER->loggedin = true;
            $USER->site     = $CFG->wwwroot; // for added security, store the site in the 
            
            update_user_login_times();
            
            // Don't show username on login page
            set_moodle_cookie('nobody');

            set_login_session_preferences();
            
            unset($SESSION->lang);
            
            // remove stork credentials from session
            unset($_SESSION['STORK_SESSION']);
            
            $SESSION->justloggedin = true;
            
            add_to_log(SITEID, 'user', 'login', "view.php?id=$USER->id&course=".SITEID, $USER->id, 0, $USER->id);
            
            if (user_not_fully_set_up($USER)) {
                $urltogo = $CFG->wwwroot.'/user/edit.php?id='.$USER->id.'&amp;course='.SITEID;
                // We don't delete $SESSION->wantsurl yet, so we get there later

            } else if (isset($SESSION->wantsurl) and (strpos($SESSION->wantsurl, $CFG->wwwroot) === 0)) {
                $urltogo = $SESSION->wantsurl;    /// Because it's an address in this site
                unset($SESSION->wantsurl);

            } else {
                $urltogo = $CFG->wwwroot.'/';      /// Go to the standard home page
                unset($SESSION->wantsurl);         /// Just in case
            }

            /// Go to my-moodle page instead of homepage if mymoodleredirect enabled
            if (!has_capability('moodle/site:config',get_context_instance(CONTEXT_SYSTEM)) and !empty($CFG->mymoodleredirect) and !isguest()) {
                if ($urltogo == $CFG->wwwroot or $urltogo == $CFG->wwwroot.'/' or $urltogo == $CFG->wwwroot.'/index.php') {
                    $urltogo = $CFG->wwwroot.'/my/';
                }
            }

            check_enrolment_plugins($USER);
            load_all_capabilities();     /// This is what lets the user do anything on the site  :-)

            redirect($urltogo);
            
            exit;
			
		} else {
			// get request did not complete successfully
			print_error('stork_contacting_connector_error', 'auth');
			exit;
		}
	} else {
		// no ticket has been provided
		print_error('stork_invalid_invocation_error', 'auth');
		exit;
	}

?>
