<?php
require_once ($CFG->dirroot.'/course/moodleform_mod.php');

class mod_chat_mod_form extends moodleform_mod {

    function definition() {

        global $CFG;
        $mform    =& $this->_form;

//-------------------------------------------------------------------------------
        $mform->addElement('header', 'general', get_string('general', 'form'));

        $mform->addElement('text', 'name', get_string('chatname', 'chat'), array('size'=>'64'));
        if (!empty($CFG->formatstringstriptags)) {
            $mform->setType('name', PARAM_TEXT);
        } else {
            $mform->setType('name', PARAM_CLEAN);
        }
        $mform->addRule('name', null, 'required', null, 'client');

        $mform->addElement('htmleditor', 'intro', get_string('chatintro', 'chat'));
        $mform->setType('intro', PARAM_RAW);
        $mform->setHelpButton('intro', array('writing', 'questions', 'richtext'), false, 'editorhelpbutton');
        $mform->addRule('intro', get_string('required'), 'required', null, 'client');

        $mform->addElement('date_time_selector', 'chattime', get_string('chattime', 'chat'));

        $options=array();
        $options[0]  = get_string('donotusechattime', 'chat');
        $options[1]  = get_string('repeatnone', 'chat');
        $options[2]  = get_string('repeatdaily', 'chat');
        $options[3]  = get_string('repeatweekly', 'chat');
        $mform->addElement('select', 'schedule', get_string('repeattimes', 'chat'), $options);


        $options=array();
        $options[0]    = get_string('neverdeletemessages', 'chat');
        $options[365]  = get_string('numdays', '', 365);
        $options[180]  = get_string('numdays', '', 180);
        $options[150]  = get_string('numdays', '', 150);
        $options[120]  = get_string('numdays', '', 120);
        $options[90]   = get_string('numdays', '', 90);
        $options[60]   = get_string('numdays', '', 60);
        $options[30]   = get_string('numdays', '', 30);
        $options[21]   = get_string('numdays', '', 21);
        $options[14]   = get_string('numdays', '', 14);
        $options[7]    = get_string('numdays', '', 7);
        $options[2]    = get_string('numdays', '', 2);
        $mform->addElement('select', 'keepdays', get_string('savemessages', 'chat'), $options);

        $mform->addElement('selectyesno', 'studentlogs', get_string('studentseereports', 'chat'));

//-------------------------------------------------------------------------------
        $mform->addElement('header', '', get_string('stork', 'chat'));

        $minagegrp=array();
        $minagegrp[] = &$mform->createElement('text', 'minage');
        $minagegrp[] = &$mform->createElement('checkbox', 'minageenabled', '', get_string('enabled', 'chat'));
        $mform->addGroup($minagegrp, 'minagegrp', get_string('minage', 'chat'), array(' '), false);
        $mform->setType('minage', PARAM_TEXT);
        $mform->addRule('minage', null, 'numeric', null, 'client');
        $mform->disabledIf('minage', 'minageenabled');
        
        $maxagegrp=array();
        $maxagegrp[] = &$mform->createElement('text', 'maxage');
        $maxagegrp[] = &$mform->createElement('checkbox', 'maxageenabled', '', get_string('enabled', 'chat'));
        $mform->addGroup($maxagegrp, 'maxagegrp', get_string('maxage', 'chat'), array(' '), false);
        $mform->setType('maxage', PARAM_TEXT);
        $mform->addRule('maxage', null, 'numeric', null, 'client');
        $mform->disabledIf('maxage', 'maxageenabled');

        $options=array();
        $options[0] = get_string('noqaalevelrequired', 'chat');
        $options[1] = get_string('qaalevel_1', 'chat');
        $options[2] = get_string('qaalevel_2', 'chat');
        $options[3] = get_string('qaalevel_3', 'chat');
        $options[4] = get_string('qaalevel_4', 'chat');
        $mform->addElement('select', 'minqaalevel', get_string('minqaalevel', 'chat'), $options);
        
//-------------------------------------------------------------------------------
        $features = new stdClass;
        $features->groups = true;
        $features->groupings = true;
        $features->groupmembersonly = true;
        $this->standard_coursemodule_elements($features);

        $this->add_action_buttons();
    }
    
    function data_preprocessing(&$default_values){
    	// if no minage has been provided, disable checkbox
        if (empty($default_values['minage'])){
            $default_values['minageenabled'] = 0;
        }        
            if (empty($default_values['maxage'])){
            $default_values['maxageenabled'] = 0;
        }        
    }

    function get_data($slashed=true) {
    	$data = parent::get_data($slashed);
    	if (isset($data)) {
    		// work around: no values for unchecked checkboxes are submitted
    		if (!isset($data->minageenabled)) {
    			$data->minageenabled = 0;
    			$data->minage = 0;
    		}
    	 	if (!isset($data->maxageenabled)) {
    			$data->maxageenabled = 0;
    			$data->maxage = 0;
    		}
    	}
    	return $data;
    }
    
}
?>
